using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Transactions;
using System.Windows.Forms;

namespace TxFAndWcf.Client
{
    public partial class Form1 : Form
    {
        private TransactionScope myTransactionScope;

        #region Constructors

        public Form1()
        {
            InitializeComponent();
        }

        #endregion

        #region Transaction Management

        private void startButton_Click(object sender, EventArgs e)
        {
            if (Transaction.Current == null)
            {
                myTransactionScope = new TransactionScope();

                statusLabel.Text = "Transaction Started...";
            }
            else
            {
                statusLabel.Text = "Transaction Already Started...";
            }
        }

        private void commitButton_Click(object sender, EventArgs e)
        {
            if (myTransactionScope != null)
            {
                myTransactionScope.Complete();
                myTransactionScope.Dispose();

                statusLabel.Text = "Committed Transaction";
            }
        }

        private void rollbackButton_Click(object sender, EventArgs e)
        {
            // If we are in a transaction, just dispose the scope to rollback
            if (Transaction.Current != null)
            {
                myTransactionScope.Dispose();

                statusLabel.Text = "Rolled Transaction Back...";
            }
        }

#endregion

        private void createReportButton_Click(object sender, EventArgs e)
        {
            statusLabel.Text = "Calling Report Creator...";

            ReportCreatorClient reportCreator = new ReportCreatorClient();
            reportCreator.CreateReport("myReport.txt");

            statusLabel.Text = "Report Created...";
        }

        protected override void OnClosed(EventArgs e)
        {
            if (Transaction.Current != null)
                myTransactionScope.Dispose();

            base.OnClosed(e);
        }
    }
}