using System;
using System.Collections.Generic;
using System.IO;
using System.ServiceModel;
using System.Text;
using System.Transactions;
using Microsoft.KtmIntegration;

namespace TxFAndWcf.Server
{
    class ReportCreatorService : IReportCreator
    {
        private DirectoryInfo myFileStore = new DirectoryInfo(Path.Combine(Directory.GetCurrentDirectory(), "Reports"));
        
        [OperationBehavior(TransactionScopeRequired = true, TransactionAutoComplete = true)]
        public void CreateReport(string reportName)
        {
            Console.WriteLine("Writing Report");

            // Create file store if necessary
            if (!myFileStore.Exists)
                myFileStore.Create();

            // Write report
            FileInfo report = new FileInfo(Path.Combine(myFileStore.FullName, reportName));
            using (StreamWriter writer = new StreamWriter(TransactedFile.Open(
                report.FullName,
                FileMode.Create,
                FileAccess.Write,
                FileShare.Write)))
            {
                writer.WriteLine("This is my report");
            }

            Console.WriteLine("Report Written\n");
        }
    }
}
